#include "TableModel.h"

#pragma hdrstop

namespace dbase {

  TableModel::TableModel( const DBASE* db, QObject* parent /*= NULL*/ )
    : QAbstractTableModel( parent )
    , _db( db )
  {
  }


  TableModel::~TableModel(void)
  {
  }

  int TableModel::rowCount( const QModelIndex& index ) const {
    return (int)_db->getRecords().size();
  }

  int TableModel::columnCount( const QModelIndex& index ) const {
    return (int)_db->getFields().size();
  }

  QVariant TableModel::headerData ( int section, Qt::Orientation orientation, int role ) const {
    if( orientation != Qt::Horizontal || role != Qt::DisplayRole ) {
      return QAbstractTableModel::headerData( section, orientation, role );
    }

    return _db->getFields()[ section ].getName();
  }

  QVariant TableModel::data( const QModelIndex& index, int role ) const {
    if( !index.isValid() || role != Qt::DisplayRole ) {
      return QVariant();
    }

    const DBASE::Records& records = _db->getRecords();
    const Record& record = records.at( index.row() );

    return record.get( index.column() );
  }
}