#pragma once

#include <QAbstractTableModel>

#include "dbase.h"

namespace dbase {

  class  TableModel : public QAbstractTableModel {
  public:
    TableModel( const DBASE* db, QObject* parent = NULL );
    ~TableModel(void);

    int rowCount( const QModelIndex& index ) const;

    int columnCount( const QModelIndex& index ) const;

    QVariant data( const QModelIndex& index, int role ) const;

    QVariant headerData ( int section, Qt::Orientation orientation, int role = Qt::DisplayRole ) const;

    const DBASE* getDBASE() const { return _db; }

    bool isValid() const { return _db == NULL ? false : _db->isValid(); }

  private: 
    const DBASE* _db;
  };

}
