#pragma once

#include "TableModel.h"

#include "ui_Viewer.h"


namespace dbase {

  class Viewer : public QWidget {
    Q_OBJECT

  public:
    Viewer( QWidget* parent = NULL );

    void setDirectory( const QString& dir );

  protected slots:
     void itemClicked( QListWidgetItem * item );
     void searchTextChanged( const QString& text );

     void deleteCache(bool reloadCurrent = true);

     void removeEmptyFiles(int s);

     void writeSchema();

  private:
    inline void highlight( QListWidgetItem * item, bool b ) const { QFont f( item->font() ); if( f.bold() == b ) { return; } f.setBold( b ); item->setFont( f ); }
    void updateCacheProgressBar() { ui.progressBarCache->setValue( _cacheSize / (1024*1024) ); }

    QMap< QString, TableModel* > _models;

    Ui::Viewer ui;
    qint64 _cacheSize;
  };

}

